#include "sysutils.h"

#include <stddef.h>
#include <stdlib.h>
#include <string.h>

#include <sys/prctl.h>

#define PRCTL_ARG(x) (unsigned long)(x)

int setprocname(const char *name) {
  return prctl(PR_SET_NAME, name, NULL, NULL, NULL);
}

int setproctitle(const char *title) {
  int ret = 0;

  static char *arg_start = NULL;

  size_t argv_len = strlen(title) + 1;
  char *argv = realloc(arg_start, argv_len);
  if (argv == NULL)
    return -1;

  arg_start = argv;
  uint64_t arg_end = (size_t)arg_start + argv_len;

  ret = prctl(PR_SET_MM, PRCTL_ARG(PR_SET_MM_ARG_START), PRCTL_ARG(arg_start),
              PRCTL_ARG(0), PRCTL_ARG(0));
  if (ret != 0) {
    return 1;
  }

  ret = prctl(PR_SET_MM, PRCTL_ARG(PR_SET_MM_ARG_END), PRCTL_ARG(arg_end),
              PRCTL_ARG(0), PRCTL_ARG(0));
  if (ret == 0)
    (void)strncpy(arg_start, title, argv_len);

  return ret;
}
